zoukankan      html  css  js  c++  java
  • Codeforces Round #201.C-Alice and Bob

    C. Alice and Bob

    time limit per test

    2 seconds

    memory limit per test

    256 megabytes

    input

    standard input

    output

    standard output

    It is so boring in the summer holiday, isn't it? So Alice and Bob have invented a new game to play. The rules are as follows. First, they get a set of n distinct integers. And then they take turns to make the following moves. During each move, either Alice or Bob (the player whose turn is the current) can choose two distinct integers x and y from the set, such that the set doesn't contain their absolute difference |x - y|. Then this player adds integer |x - y| to the set (so, the size of the set increases by one).

    If the current player has no valid move, he (or she) loses the game. The question is who will finally win the game if both players play optimally. Remember that Alice always moves first.

    Input

    The first line contains an integer n (2 ≤ n ≤ 100) — the initial number of elements in the set. The second line contains n distinct space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 109) — the elements of the set.

    Output

    Print a single line with the winner's name. If Alice wins print "Alice", otherwise print "Bob" (without quotes).

    大意:

    n(n<=100)个正数,每次从中取任意两个数,他们的差值如果在集合中没有就加入集合中,问最后集合中元素个数的奇偶性?

    思路:

    快被自己蠢哭了。。。。竟然把题目读成了取出两个数,然后放回去。。。。。

    首先,要明白一点,最终谁获胜,需要确定还缺几个数(还能够生成多少数)

  • 首先考虑只有两个数的情况,发现两个数x,y(x>y),可以观察到连续执行操作,可以生成的数的集合是

    {k∗gcd(x,y) | k=1,2,..且 k∗gcd(x,y)<=y}

  • 然后考虑有第三个数Z的情况,因为前面的两个数,极其生成的所有数的最大公约数都是gcd(x, y),
    所以加入第三个数之后这个集合的新的最大公约数是gcd(gcd(x,y),Z),然后生成集合是以这个最大公约数的倍数来生成.
  • ……..
  • 归纳到n个数,就是以最大的数为上界,所有n个数的最大公约数来填充的集合,元素个数为:

    max{xi | 1<=i<=n}gcd{x1,x2,...xn}

  • 代码:

    #include<bits/stdc++.h>
    using namespace std;
    const int MAXN=130;
    int a[MAXN];
    int gcd(int x,int y)
    {
        if(y==0) return x;
        return gcd(y,x%y);
    }
    int main()
    {
        int n;
        cin>>n;
        int m=-1;
        for(int i=0;i<n;i++){
            cin>>a[i];
            m=max(m,a[i]);
        }
        sort(a,a+n);
        int res=gcd(a[n-1],a[n-2]);
        for(int i=n-3;i>=0;i--){
            res=gcd(max(res,a[i]),min(res,a[i]));
            if(res==1) break;
        }
        int total=m/res-n;
        if(total%2) cout<<"Alice"<<endl;
        else cout<<"Bob"<<endl;
    }
查看全文
  • 相关阅读:
    pkuwc2019自闭记
    一些多项式的整理
    Codeforces 1085G(1086E) Beautiful Matrix $dp$+树状数组
    Codeforces 1083C Max Mex 线段树
    Codeforces 1090J $kmp+hash+$二分
    Codeforces 1073G Yet Another LCP Problem $SA$+单调栈
    Codedforces 1076G Array Game 线段树
    LuoguP5017 摆渡车 $dp$
    NOIP2018游记
    解决python3 安装turtle的问题
  • 原文地址:https://www.cnblogs.com/liuzhanshan/p/6557025.html
  • Copyright © 2011-2022 走看看